unit UMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ToolWin, ComCtrls, Menus, ExtCtrls, StdCtrls, Grids, DBGrids, DAODatabase,
  Db, DAODataset, DAOQuery;

type
  TMainFrm = class(TForm)
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    View1: TMenuItem;
    New1: TMenuItem;
    N1: TMenuItem;
    Properties1: TMenuItem;
    Delete1: TMenuItem;
    N2: TMenuItem;
    Close1: TMenuItem;
    Sortby1: TMenuItem;
    ImageList1: TImageList;
    N3: TMenuItem;
    Find1: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    DBGrid1: TDBGrid;
    DAODatabase1: TDAODatabase;
    Persons: TDAOQuery;
    DataSource1: TDataSource;
    PersonsNAME: TStringField;
    PersonsFIRST: TStringField;
    PersonsMIDDLE: TStringField;
    PersonsLAST: TStringField;
    PersonsEMAIL: TStringField;
    PersonsADDRESS: TMemoField;
    PersonsCITY: TStringField;
    PersonsSTATE: TStringField;
    PersonsZIPCODE: TStringField;
    PersonsCOUNTRY: TStringField;
    PersonsPHONE: TStringField;
    PersonsFAX: TStringField;
    PersonsCELLULAR: TStringField;
    PersonsADDITIONAL: TMemoField;
    PopupMenu1: TPopupMenu;
    NewContact1: TMenuItem;
    N4: TMenuItem;
    Properties2: TMenuItem;
    N5: TMenuItem;
    Find2: TMenuItem;
    Name1: TMenuItem;
    EMailAddress1: TMenuItem;
    Phone1: TMenuItem;
    Cellular1: TMenuItem;
    PersonsHOMEPAGE: TStringField;
    procedure New1Click(Sender: TObject);
    procedure Properties1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Name1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainFrm: TMainFrm;

implementation

uses UAdrEdit;

{$R *.DFM}

procedure TMainFrm.New1Click(Sender: TObject);
begin
  Persons.Insert;
  AdrEditFrm.ShowModal;
end;

procedure TMainFrm.Properties1Click(Sender: TObject);
begin
  if Persons.RecordCount > 0 then AdrEditFrm.ShowModal;
end;

procedure TMainFrm.Delete1Click(Sender: TObject);
begin
  if Persons.RecordCount > 0 then Persons.Delete;
end;

procedure TMainFrm.FormCreate(Sender: TObject);
begin
  DAODatabase1.DatabaseName := ExtractFilePath(Application.ExeName) + 'Addrbook.mdb';
  try
    DAODatabase1.Open;
    Persons.Open;
  except
    ShowMessage('Error while opening database.');
    Halt;
  end;
end;

procedure TMainFrm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainFrm.Edit1Change(Sender: TObject);
begin
  Persons.Close;
  if Edit1.Text = '' then
    Persons.MacroByName('where').Clear
  else
    Persons.MacroByName('where').Value := 'WHERE NAME LIKE "'+Edit1.Text+'*"';
  Persons.Open;
end;

procedure TMainFrm.Name1Click(Sender: TObject);
begin
  Persons.Close;
  case (Sender as TMenuItem).Tag of
    1: Persons.MacroByName('order').Value := 'NAME';
    2: Persons.MacroByName('order').Value := 'EMAIL';
    3: Persons.MacroByName('order').Value := 'PHONE';
    4: Persons.MacroByName('order').Value := 'CELLULAR';
  end;
  Persons.Open;
  (Sender as TMenuItem).Checked := True;
end;

end.
