unit testmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, BaseDate, ComCtrls, Buttons, ExtCtrls, Grids, Calendar, ModCal;

type
  TForm1 = class(TForm)
    E_MJD: TEdit;
    E_year: TEdit;
    E_month: TEdit;
    E_day: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    YMDToDateTime: TBitBtn;
    b_ymdToMJD: TBitBtn;
    BitBtn3: TBitBtn;
    b_DTtoMJD: TBitBtn;
    b_mjdtoymd: TBitBtn;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    y2: TEdit;
    m2: TEdit;
    d2: TEdit;
    UpDown3: TUpDown;
    UpDown4: TUpDown;
    Label9: TLabel;
    e_MJD2: TEdit;
    bMJD2toYMD: TBitBtn;
    Panel1: TPanel;
    Label4: TLabel;
    Memo1: TMemo;
    DateTimePicker1: TDateTimePicker;
    bRollup: TBitBtn;
    Calendar1: TCalendar;
    b_MSDateToCal: TBitBtn;
    L_cal1Month: TLabel;
    L_cal1year: TLabel;
    b_MJDToCal: TBitBtn;
    L_MJDCalMonth: TLabel;
    L_MJDCalYear: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure YMDToDateTimeClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure b_DTtoMJDClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure b_mjdtoymdClick(Sender: TObject);
    procedure bRollupClick(Sender: TObject);
    procedure b_ymdToMJDClick(Sender: TObject);
    procedure b_MSDateToCalClick(Sender: TObject);
    procedure b_MJDToCalClick(Sender: TObject);
  private
    EnglishCalendar : tEnglishCalendar;
    TestCal : tModCal;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  EnglishCalendar := TEnglishCalendar.create;
  TestCal := TModcal.create(self);
  with TestCal do begin
    left := 6;
    top := Calendar1.top;
    parent := self;
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var test : tdatetime;
begin
  test := EnglishCalendar.MSDatefromMJD(strToInt(e_mjd.text));
  memo1.lines.add('raw tdatetime = '+ floattostr(test));

  memo1.lines.add('date is '+ FormatDateTime('dd mmm yyyy', test));
end;

procedure TForm1.Button2Click(Sender: TObject);
var test : tMJD;
begin
  test := EnglishCalendar.MJDfromMSDate(strToInt(e_mjd.text));
  memo1.lines.add('raw MJD = '+ floattostr(test));
end;

procedure TForm1.YMDToDateTimeClick(Sender: TObject);
begin
  with DateTimePicker1 do begin
    date := encodedate(StrToInt(e_Year.text), StrToInt(e_Month.text), StrToInt(e_Day.text));
    application.ProcessMessages;
    invalidate;
    with memo1.lines do begin
      clear;
      add('sent YMD ('+e_year.text+' '+e_month.text+' '+e_day.text+') to DateTimePicker');
      add('raw tdatetime = '+ floattostr(date));
      add('date is '+ FormatDateTime('dd mmm yyyy', date));
      add('weekday is '+FormatDateTime('dddd',date));
      end;
    end;

end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var CalendarDate : tCalendarDate;
begin
  CalendarDate := EnglishCalendar.DecodeDate(StrToInt(e_MJD2.text));
  with CalendarDate do begin
    y2.text := IntToStr(year);
    m2.text := IntToStr(Month);
    d2.text := IntToStr(day);
    end;
end;

procedure TForm1.b_DTtoMJDClick(Sender: TObject);
var test : tMJD;
begin
  test := EnglishCalendar.MJDfromMSDate(DateTimePicker1.date);
  e_mjd2.text := floatToStr(test);
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  with DateTimePicker1 do begin
    date := EnglishCalendar.MSDatefromMJD(strToInt(e_mjd.text));
    invalidate;
    with memo1.lines do begin
      clear;
      add('sent MJD '+e_mjd.text+ ' to DateTimePicker');
      add('raw tdatetime = '+ floattostr(date));
      add('date is '+ FormatDateTime('dd mmm yyyy', date));
      add('weekday is '+FormatDateTime('dddd',date));
      end;
    end;
end;

procedure TForm1.b_mjdtoymdClick(Sender: TObject);
var CalendarDate : tCalendarDate;
begin
  CalendarDate := EnglishCalendar.DecodeDate(StrToInt(e_MJD.text));
  with CalendarDate do begin
    y2.text := IntToStr(year);
    m2.text := IntToStr(Month);
    d2.text := IntToStr(day);
    end;

end;

procedure TForm1.bRollupClick(Sender: TObject);
begin
  e_year.text :=  y2.Text;
  e_month.text := m2.text;
  e_day.text := d2.text;
end;

procedure TForm1.b_ymdToMJDClick(Sender: TObject);
var MJD : tmjd;
begin
  MJD := EnglishCalendar.EncodeDate(StrToInt(e_Year.text), StrToInt(e_Month.text), StrToInt(e_Day.text));
  e_MJD.text := IntToStr(trunc(MJD));
end;

procedure TForm1.b_MSDateToCalClick(Sender: TObject);
var ayear, amonth, aday : word;
begin
  with Calendar1 do begin
    DecodeDate(DateTimePicker1.date, ayear, amonth, aday);
    year := ayear;
    month := amonth;
    day := aday;
    l_cal1month.caption := LongMonthNames[month];
    l_cal1Year.caption := IntToStr(year);
    end;
end;

procedure TForm1.b_MJDToCalClick(Sender: TObject);
var YMD : TCalendarDate;
begin
  with TestCal do begin
    YMD := EnglishCalendar.DecodeDate(StrToInt(e_MJD.text));
    year := YMD.year;
    month := YMD.month;
    day := YMD.Day;
    l_MJDCalmonth.caption := EnglishCalendar.Yeardef.MonthName[month];
    l_MJDCalYear.caption := IntToStr(year);
    end;
end;

end.
